package inria.paperoles.customization;

import java.util.Collection;
import java.util.Iterator;
import java.util.Vector;

import javax.swing.JOptionPane;

import org.ximtec.igesture.algorithm.AlgorithmException;
import org.ximtec.igesture.core.GestureClass;
import org.ximtec.igesture.core.Result;
import org.ximtec.igesture.core.ResultSet;

import edu.umd.cs.piccolo.PCamera;

import inria.paperoles.gestures.recognition.GeneralizedGestureClass;
import inria.paperoles.gestures.recognition.ParameterRecognitionManager;
import inria.paperoles.gestures.recognition.RecognitionManager;
import inria.paperoles.grammar.AssociatedComplexGesture;
import inria.paperoles.grammar.ComplexGesture;
import inria.paperoles.grammar.ConnectedComplexGesture;
import inria.paperoles.grammar.GroupingGesture;
import inria.paperoles.grammar.Token;
import inria.paperoles.grammar.Unknown;
import inria.paperoles.ui.GestureBrowser;
import inria.paperoles.ui.GesturePath;
import inria.paperoles.ui.GesturesCanvas;
import inria.paperoles.ui.GesturesContainer;
import inria.paperoles.ui.ScoreViewer;

public class ClassifyAllCommand extends QueryCommand{

	public ClassifyAllCommand(GesturesContainer gcontainer) {
		super(gcontainer);
	}

	public void activate(GestureClass gclass){
		//Iterator childIterator = canvas.getChildrenIterator();
		
		GestureBrowser gbrowser = gcontainer.getBrowserFrame();
			//(GestureBrowser)((ScoreViewer)((PCamera)canvas.getRoot().getChild(0)).getComponent()).getTopLevelAncestor();
		
		// not sure if i should initialize the recognizer here or possibly ealier, after defining the last gesture
		
		RecognitionManager reconManager = gbrowser.getRecognitionManager();
	
		for(GesturePath gpath:gcontainer.getGestures()){

			if(/*gpath.getGestureClass() == null */gpath.getGestureClass() != gclass)
				try {
					recognizeGesture(reconManager, gpath);
				} catch (AlgorithmException e) {
					// TODO Auto-generated catch block
					//e.printStackTrace();
					continue;
				}
		}
//		gbrowser.getSyntaxAnalyzer().matchOperations(null);
	}
	
	
	private void recognizeGesture(RecognitionManager reconManager, GesturePath gpath) throws AlgorithmException{
		if(gpath.getToken() instanceof GroupingGesture 
				|| gpath.getToken() instanceof Unknown) return;
		else if(gpath.getToken() instanceof ComplexGesture) {
			Vector<Token> subtokens = ((ComplexGesture)gpath.getToken()).getSubTokens();
			for(int i=1; i<subtokens.size(); ++ i)		
				recognizeGesture(reconManager, subtokens.elementAt(i).getGesturePath(gpath.getCanvas()));	
		}
		else reconManager.recognizeGesture(gpath);
	}

	
}
