package inria.paperoles.customization;

import java.util.Collection;
import java.util.Iterator;
import java.util.Vector;

import inria.paperoles.gestures.recognition.GeneralizedGestureClass;
import inria.paperoles.ui.GesturePath;
import inria.paperoles.ui.GesturesCanvas;
import inria.paperoles.ui.GesturesContainer;

public class GestureFilteringCommand extends QueryCommand {

	public GestureFilteringCommand(GesturesContainer gcontainer) {
		super(gcontainer);
		// TODO Auto-generated constructor stub
	}

	
	public void activate(Object context){
		Vector gclasses = (Vector)context;

		for(GesturePath gpath:gcontainer.getGestures()){			
			Collection<GeneralizedGestureClass> classes = gpath.getGestureClasses();
		
			if(gclasses!= null && !gclasses.isEmpty() && !overlap(gclasses, classes)) gpath.setDisabled();
			else gpath.setNormal();
		}
	}
	
	private boolean overlap(Collection<GeneralizedGestureClass> classes1, Collection<GeneralizedGestureClass> classes2){
		if(classes1 == null || classes2 == null) return false;
		
		for(GeneralizedGestureClass gestureclass:classes1)
			if(classes2.contains(gestureclass)) return true;
		
		return false;
		
	}
}
