package inria.paperoles.customization;

import java.awt.geom.Point2D;

import inria.paperoles.ui.GesturePath;

public class GestureManipulationCommand implements Command{

	String name;
	GesturePath gesture;
	boolean active = true;
	
	public GestureManipulationCommand(String name, GesturePath gesture){
		this.name = name;
		this.gesture = gesture; 
	}
	
	public String getName(){
		return name;
	}

	public GesturePath getGesturePath(){
		return gesture;
	}

	
	public boolean isActive(){
		return active;
	}
	
	public void activate(Object context){
		System.err.println(name + " on " + gesture);
		gesture.setNormal();
	}
}
