package inria.paperoles.docmodel;

import inria.paperoles.ui.GesturePath;

import java.awt.Shape;
import java.awt.geom.Area;
import java.util.Collection;
import java.util.Iterator;
import java.util.Vector;

import edu.umd.cs.piccolo.nodes.PPath;

public class DocSkeleton extends PPath {

	// This is a first simplified version...
//	Vector<Symbol> symbols;
	
	PPath skeleton;
	PPath symbols;
	
	public DocSkeleton(){
		super();
		
		skeleton = new PPath();
		symbols = new PPath();
		
		addChild(skeleton);
		addChild(symbols);
	}
	
	public void addSymbol(Symbol symbol){
		symbols.addChild(symbol);
	}
	
	public void removeSymbol(Symbol symbol){
		symbols.removeChild(symbol);
	}
	
	public void addDocPart(DocPart part){
		skeleton.addChild(part);
		part.moveToBack();
	}
	
	public SymbolGroup selectGroup(Collection<Constraint> constraints){
		
		return null;
	}

	public Collection<DocPart> getSkeletonParts(){
		return skeleton.getAllNodes();
	}
	
	
	public Collection<Symbol> select(Shape shape){
		Vector<Symbol> selectedSymbols = new Vector<Symbol>();
		
		Iterator<Symbol> iterator = symbols.getChildrenIterator();

		while(iterator.hasNext()){ 
			Symbol symbol = iterator.next();			
			
			if(shape == null || shape.contains(symbol.getCenter())) selectedSymbols.add(symbol);
		}
		
		return selectedSymbols;
	}	
	
}
