package inria.paperoles.docmodel;

import inria.paperoles.scoremodel.WaveLine;

import java.awt.Color;
import java.awt.geom.Line2D;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;

import edu.umd.cs.piccolo.nodes.PPath;

public class Symbol extends PPath{

	final static Color STROKE_COLOR = new Color(80, 80, 150);
	final static Color FOCUS_STROKE_COLOR = new Color(220, 150, 100);
	
	public Symbol(){
		
	}
	
	public Symbol(int x, int y, int width, int height){
		super();
		
		setStrokePaint(STROKE_COLOR );
		setPathToRectangle(x, y, width, height);
	}		
	
	public Point2D getCenter(){
		return new Point2D.Double(getBounds().getCenterX(), getBounds().getCenterY());
	}
	
	public void setSkeleton(Line2D skeleton){
		addChild(new PPath(skeleton));
	}
	
	
	public void setSelected(boolean selected){
		if(selected) setStrokePaint(Color.red);
		else setStrokePaint(STROKE_COLOR);
	}
	
//	private boolean selected = false;
	public void setFocus(boolean focus){
		if(focus) setStrokePaint(FOCUS_STROKE_COLOR);
		else setStrokePaint(STROKE_COLOR);
	}


}
