package inria.paperoles.grammar;

import inria.paperoles.docmodel.Symbol;
import inria.paperoles.scoping.ScopeInstance;
import inria.paperoles.scoremodel.MultiplePageSkeleton;
import inria.paperoles.scoremodel.ScoreSkeleton;
import inria.paperoles.scoremodel.ScoreVerticalPointer;
import inria.paperoles.scoremodel.Voice;
import inria.paperoles.ui.GesturesCanvas;

import java.awt.Rectangle;
import java.awt.Shape;
import java.util.Collection;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

public class BoundedScope extends PrintedScope{

	ScopeInstance scopeInstance;
	Hashtable<GesturesCanvas, PrintedScope> scopes;
	
/*	public BoundedScope(ScopeInstance scopeInstance, ScoreSkeleton skeleton){
		super(null, skeleton.select(scopeInstance.getScope()), scopeInstance.getScope().get(skeleton));
	}*/
	
	public BoundedScope(ScopeInstance scopeInstance, Collection<GesturesCanvas> canvases, int type){// Collection<Symbol> symbols) {
		//super(symbols, scopeInstance.getScope());
		super(null, null, type);
	
		this.scopeInstance = scopeInstance;
	
		scopes = new Hashtable<GesturesCanvas, PrintedScope>();
		
		Vector<Symbol> tmpsymbols = new Vector<Symbol>();
		
		for(GesturesCanvas canvas:canvases){ 
			Shape shape = scopeInstance.getScope().get(canvas.getPageSkeleton());
			
			scopes.put(canvas, new PrintedScope(canvas, scopeInstance.getStartPointer().getPolyStaff(), shape, type));
			
			tmpsymbols.addAll(canvas.getPageSkeleton().select(shape));	
		}
		
		symbols = tmpsymbols;
	}
	

	public double getArea(){
		double area = 0;

		Enumeration<GesturesCanvas> canvases = scopes.keys();
		for(GesturesCanvas canvas = canvases.nextElement(); canvases.hasMoreElements(); canvas = canvases.nextElement())
			area += getArea(canvas);
		
		return area;
	}
	
	
	public double getArea(GesturesCanvas canvas){
		Rectangle rect = getShape(canvas).getBounds();
		
		return rect.getWidth()*rect.getHeight();
	}
	
	public Shape getShape(GesturesCanvas canvas){
		return scopes.get(canvas).getShape();
	}
	
	public boolean inGesturesCanvas(GesturesCanvas gcanvas){
		return scopes.get(gcanvas) !=null;
	}
	
	public PrintedScope get(GesturesCanvas gcanvas){
		return scopes.get(gcanvas);
	}

	public boolean equals(Object o){
		if(this == o) return true;
	
		Enumeration<GesturesCanvas> canvases = scopes.keys();
		for(GesturesCanvas canvas = canvases.nextElement(); canvases.hasMoreElements(); canvas = canvases.nextElement()){	
			if(!getShape(canvas).getBounds().equals(((BoundedScope)o).getShape(canvas).getBounds())) return false;
		}
		
		return true;
	}
	
}
