package inria.paperoles.grammar;

import java.awt.geom.Line2D;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;
import java.util.List;
import java.util.Vector;

import papertoolkit.pen.PenSample;

import inria.paperoles.gestures.GeneralInkStroke;
import inria.paperoles.gestures.SingleInkStroke;
import inria.paperoles.gestures.SingleStrokeAnalysisResult;
import inria.paperoles.scoping.ScopeInstance;
import inria.paperoles.scoremodel.Measure;
import inria.paperoles.scoremodel.PolyStaff;
import inria.paperoles.scoremodel.ScorePart;
import inria.paperoles.scoremodel.ScoreSkeleton;
import inria.paperoles.scoremodel.Voice;
import inria.paperoles.scoremodel.VoiceLine;
import inria.paperoles.ui.GesturesCanvas;
import inria.paperoles.ui.GlobalParameters;

public class Horizontal extends Token {

	boolean isCurve = false;
	
	public Horizontal(GeneralInkStroke stroke, GesturesCanvas gcanvas, boolean b) {
		super(stroke, gcanvas);
		isCurve = b;
		
		if(b){
			types = new int[1];
			types[0] = Scope.NONE;
		}
		
		else {
			types = new int[1];
			types[0] = Scope.STAFF_CLOSEST;	
		}
	}
 

	public boolean isCurve(){
		return isCurve;
	}
	
	
	public String toString(){	
		return "General Stroke";
	}
	
	/*
	
	private static  Object[] filterPoints(List<PenSample> list){
		
		PenSample currentSample = null;
		Vector<PenSample> newlist = new Vector<PenSample>();
		
		for(PenSample sample:list){
			if(currentSample == null || sample.getX() != currentSample.getX() || sample.getY() != currentSample.getY())
				newlist.addElement(sample);
		}
			
		if(newlist.size() <= GlobalParameters.MAX_OSC_SIZE) return newlist.toArray();
	
		double sampleStep = (double)newlist.size()/GlobalParameters.MAX_OSC_SIZE;
		
		Object[] fsamples = new Object[GlobalParameters.MAX_OSC_SIZE];
		for(int i=0; i<GlobalParameters.MAX_OSC_SIZE; ++i)
			fsamples[i] = newlist.elementAt((int)Math.round(sampleStep*i));
		
		return fsamples;
	}
	
	private static int getAmplitude(double y, PolyStaff staff){
		return (int)Math.round(GlobalParameters.MAX_AMPLITUDE - (y - staff.getMinY())*(GlobalParameters.MAX_AMPLITUDE -
					GlobalParameters.MIN_AMPLITUDE)/staff.getHeight());
	}
	
	private static int getTime(double x, PolyStaff staff){
		if(x < staff.getMinX()) x = staff.getMinX();
		else if(x > staff.getMaxX()) x = staff.getMaxX();
			
		return (staff.getID() - 1)*GlobalParameters.STAFF_LENGTH + (int)Math.round((x - staff.getMinX())*GlobalParameters.STAFF_LENGTH/staff.getWidth());
	}
	
	
	public String getCurvePoints(){
		SingleStrokeAnalysisResult result = stroke.getAnalysisResult();
		PolyStaff staff = result.getClosestPolyStaff();
			
		Object[] samples = filterPoints(stroke.getSamples());
		
		String s = "";
		s+="( ";
		
		for(int i = 0; i<samples.length; ++i){
			s += (getTime(((PenSample)samples[i]).getX(), staff) + " ");
		}
		s+=") ( ";
		for(int i = 0; i<samples.length; ++i){
			s += (getAmplitude(((PenSample)samples[i]).getY(), staff) + " ");
		}
		s+=")";
		
		return "(" + s + ")";
	}
	
	
	public int getTimePosition(){
		SingleStrokeAnalysisResult result = stroke.getAnalysisResult();
		PolyStaff staff = result.getClosestPolyStaff();
		
		double x_min = 10000000;
		for(PenSample sample:stroke.getSamples()){
			if(sample.getX() < x_min) x_min = sample.getX();
		}
		
		return getTime(x_min, staff);
	}
	
	public String getXRange(){
		SingleStrokeAnalysisResult result = stroke.getAnalysisResult();
		PolyStaff staff = result.getClosestPolyStaff();
		
		double x_min = 10000000, x_max = 0;
		for(PenSample sample:stroke.getSamples()){
			if(sample.getX() < x_min) x_min = sample.getX();
			if(sample.getX() > x_max) x_max = sample.getX();
		}
		
		return "(" + getTime(x_min, staff) + " " + getTime(x_max, staff) + ")";
	}
	
	public String getStartPoint(){
		SingleStrokeAnalysisResult result = stroke.getAnalysisResult();
		PolyStaff staff = result.getClosestPolyStaff();
		
		PenSample sample = stroke.getSamples().get(0);
		
		return "(" + getTime(sample.getX(), staff) + " " + getAmplitude(sample.getY(), staff) + ")";
	}
	
	public String getCentralPoint(){
		SingleStrokeAnalysisResult result = stroke.getAnalysisResult();
		PolyStaff staff = result.getClosestPolyStaff();
		
		Rectangle2D bounds = stroke.getBounds();
		
		return "(" + getTime(bounds.getCenterX(), staff) + " " + getAmplitude(bounds.getCenterY(), staff) + ")";
	}
	*/
	
	/*
	public class ScoreReferencePoint{
		ScoreReferencePoint(Measure mes){
			
		}
	}
	
	public Point2D getReferencePoint(){
		SingleStrokeAnalysisResult result = stroke.getAnalysisResult();
		VoiceLine voice = null;

		voice = result.getClosestVoiceLine();
		return new Point2D.Double(voice.getBounds().getMinX(), voice.getBounds().getMaxY());
	}
	
	
	public Measure getContainingMeasure(){
		SingleStrokeAnalysisResult result = stroke.getAnalysisResult();
		VoiceLine voice = null;
		PolyStaff pstaff;
		
		if(isCurve){
			return null;
		}
		
		
		switch(activescope.type){
			case Scope.STAFF_CLOSEST:
				 voice = result.getClosestVoiceLine();
				 break;

			case Scope.NOTES_CLOSEST:
				 voice = result.getClosestVoiceLine();
				 break;
				 
			case Scope.STAFF_UNDER:
				 voice = result.getUnderVoiceLine();
				 break;
	
			case Scope.NOTES_UNDER:
				 voice = result.getUnderVoiceLine();
				 break;
				 
			case Scope.STAFF_OVER:
				voice = result.getOverVoiceLine();
				break;		
				
			case Scope.NOTES_UP:
				voice = result.getOverVoiceLine();
				 break;
				 
			case Scope.MULTISTAFF_UNDER:
				pstaff = result.getUnderPolyStaff();
				pstaff.getMeasureAtX(stroke.getBounds().getCenterX());
				
			case Scope.MULTISTAFF_OVER:
				pstaff = result.getOverPolyStaff();
				 return pstaff.getMeasureAtX(stroke.getBounds().getCenterX());
				 
			default:
				return null;
			}
		
		return voice.getMeasureAt(stroke.getBounds().getCenterX());
		
//		 return new Point2D.Double(voice.getBounds().getMinX(), voice.getBounds().getCenterY());

	}
	 */
}
