package inria.paperoles.scoremodel;

import java.awt.Shape;
import java.awt.geom.Line2D;
import java.awt.geom.Rectangle2D;
import java.util.Vector;

import inria.paperoles.docmodel.Symbol;

public class Chord extends ScorePart{
	
	Segment segment;
	Vector<Note> notes;
	int num;
	
	int center_x, center_y;
	
	/*
	public Chord() {
		notes = new Vector<Note>();
	}*/
	
	public Chord(Segment segment, int x, int y, int w, int h) {
		super(x, y, w, h);
		notes = new Vector<Note>();
		//this();
		setSegment(segment);
		center_x = x + w/2;
		center_y = y + h/2;
		//ignore for the moment the dimensions... no visual representation
	}
	
	public Measure getMeasure() {
		return segment.getMeasure();
	}
	
	public VoiceLine getVoiceLine(){
		return segment.getVoiceLine();
	}

	public void setSegment(Segment segment) {
		this.segment = segment;
		segment.addChord(this);
		
		num = segment.chords.size();
	}

	public void addNote(Note note) { 
		notes.add(note);
	}	
	
	/*
	public Shape getPointerShape() {
		return getBound;
	}*/
	
	public double getCenterX(){
		return center_x;
	}
	
	public double getCenterY(){
		return center_y;
	}
	
	public String toString(){
		return getVoiceLine().getVoice().getID() + " " + segment.getNum() + " "
			+ num;
	}
	
	/*
	public String toString(){
		return segment.getNum() + "";	
		
//		return getVoiceLine().getVoice().getID() + " " + segment.getNum() + " "
//			+ num;
	}*/
	
	public Note firstNote(){
		return notes.firstElement();
	}
	
	public Vector<Note> getNotes(){
		return notes;
	}
	
	public Shape getPointerShape() {
	//	return getBounds();
		return new Rectangle2D.Double(center_x - 2, segment.getMinY(), 4, segment.getHeight());
	}
}
