package inria.paperoles.scoremodel;

import inria.paperoles.docmodel.Symbol;

public class Note extends Symbol{

	final static int WIDTH = 4;
	final static int HEIGHT = 4;
	
	Segment segment;
	Chord chord;
	int num;
	
	public Note(){
		super();
	}
	
	public Note(int x, int y) {
		// TODO I add an offset of 20 pixels for now....
		super(x - WIDTH/2, y - HEIGHT/2, WIDTH, HEIGHT);
	}
	
	public Note(Chord chord, int x, int y, int w, int h) { 
		// TODO I add an offset of 20 pixels for now....
		super(x, y, w, h);
//		setSegment(chord.segment);
		setChord(chord);
	}
	
	public Measure getMeasure() {
		return segment.getMeasure();
	}
	
	public VoiceLine getVoiceLine(){
		return segment.getVoiceLine();
	}

	/*
	public void setSegment(Segment segment) {
		this.segment = segment;
		segment.addNote(this);
	}*/	
	
	void setChord(Chord chord) {
		this.chord = chord;
		this.segment = chord.segment;
		chord.addNote(this);
		
		num = chord.notes.size();
	}	
	
	public Chord getChord(){
		return chord;
	}
	
	public String toString(){
		return getVoiceLine().getVoice().getID() + " " + segment.getNum() + " "
			+ chord.num + " " + num;
	}
}
