package inria.paperoles.scoremodel;

import java.awt.Rectangle;
import java.awt.Shape;
import java.awt.geom.Rectangle2D;

import edu.umd.cs.piccolo.util.PBounds;

public class ScoreVerticalPointer {
	Measure measure;
	double x;
	
	public ScoreVerticalPointer(PolyStaff polyStaff, double x){
		
		for(Measure measure: polyStaff.measures){
			this.measure = measure;
			
			if(measure.getMaxX() > x) break; 
		}
		
		this.x = x;
	}
	
	public Measure getMeasure(){
		return measure;
	}
	
	public double getX(){
		return x;
	}
	
	public PolyStaff getPolyStaff(){
		return measure.getPolyStaff();
	}
	
	public ScoreSkeleton getSkeleton(){
		return measure.getPolyStaff().skeleton;
	}
	
	public boolean isBefore(ScoreVerticalPointer pointer){
		int compare = measure.compareWith(pointer.measure);
		
		if(compare == 0) return (x < pointer.x);
		else return (compare == -1) ? true:false;
	}
	
	public VoicePointer getVoicePointer(Voice voice){
		return new VoicePointer(measure.getSegment(voice), x);
	}
	
	public VoicePointer getVoicePointer(VoiceLine voiceline){
		return new VoicePointer(measure.getSegment(voiceline.voice), x);
	}

	public boolean isStartOfMeasure() {
		return x == measure.getX();
	}
	
	public boolean isEndOfMeasure(){
		return x == measure.getX() + measure.getWidth();
	}

}
