package inria.paperoles.scoremodel;

import java.awt.Shape;
import java.util.List;
import java.util.Vector;

public class Voice extends Vector<VoiceLine> implements Comparable {

	static Vector<Voice> voices = new Vector<Voice>(); 
	int id;
	
	public Voice(int id){
		super();
		this.id = id;
		
		voices.add(this);
	}

	public void addVoiceLine(VoiceLine vline){
		addElement(vline);
	}
	
	public int getID(){
		return id;
	}
	
	public static void initialize(){
		voices.removeAllElements();
	}
	
	public VoiceLine getVoiceLine(PolyStaff polyStaff){
		return elementAt(polyStaff.id - 1);	
	}
	
	static public Vector<Voice> getVoices(){
		return voices;
	}
	
	public List<VoiceLine> getLinesFrom(VoiceLine vline){
		return subList(indexOf(vline) + 1, size());
	}
	
	public List<VoiceLine> getLinesTo(VoiceLine vline){
		return subList(0, indexOf(vline));
	}
	
	static public Voice getVoice(int id){
		if(id > voices.size()) return null;
		else return voices.elementAt(id - 1);
	}

	public int compareTo(Object o) {
		if(id < ((Voice)o).id) return -1;
		else if(id > ((Voice)o).id) return 1;
		return 0;
	}
	
	// not really needs this.... but just in case something changes later
	public boolean equals(Object o){
		if(id == ((Voice)o).id) return true;
		else return false;
	}
	
}
