package inria.paperoles.scoremodel;

import edu.umd.cs.piccolo.PNode;
import inria.paperoles.docmodel.Symbol;
import inria.paperoles.grammar.Horizontal;
import inria.paperoles.ui.GesturesCanvas;
import inria.paperoles.ui.GraphPaper;

public class WavePoint extends ScorePart implements WrittenSymbol{

	final static int WIDTH = 2;
	final static int HEIGHT = 2;
	
	Horizontal waveLine;
	double x, y;
	double x_cent, y_cent;
	
	public WavePoint(){
		super();
	}
	
	public WavePoint(double x, double y, Horizontal wline) {
		super();
	
		// TODO I add an offset of 20 pixels for now....
		//super(x - WIDTH/2, y - HEIGHT/2, WIDTH, HEIGHT);
		this.x = x;
		this.y = y;
		
		x_cent = (x - GraphPaper.off_x)/GraphPaper.CENTIMETER_STEP;
		y_cent = GraphPaper.getHeightInCent() - (y - GraphPaper.off_y)/GraphPaper.CENTIMETER_STEP;
		
		waveLine = wline;
	}
	public GesturesCanvas getCanvas(){
		
		return waveLine.getCanvas();
	}
	
	public double getXInCentimeters(){

		return  x_cent;
	}
	
	public double getYInCentimeters(){
		return y_cent;
	}
	
	@Override
	public void removeFromModel() {
		// TODO Auto-generated method stub
		
	}
	
	public String toString(){
		return x_cent + ", "+y_cent;
	}


}
