package inria.paperoles.ui;

import java.awt.Color;
import java.awt.Font;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.*;

public class FileWindowPanel extends JPanel{
	JLabel showlabel;
	JLabel assignlabel;
	JLabel unassignlabel;
	JLabel refreshlabel;
	
	final static Color PRESSED_COLOR = new Color(0, 0, 100);
	final static Color DEFAULT_COLOR = new Color(0, 0, 255);
	
	public FileWindowPanel(final DataListWindow parent){
		super();
		
		showlabel = new JLabel("[show]");
		showlabel.addMouseListener(new MouseAdapter(){

			public void mousePressed(MouseEvent e) {
				if(!showlabel.isEnabled()) return;
				
				showlabel.setForeground(PRESSED_COLOR);
			}

			public void mouseReleased(MouseEvent e) {
				if(!showlabel.isEnabled()) return;
				
				showlabel.setForeground(DEFAULT_COLOR );
				parent.showSelection();
			}
		});
		
		assignlabel = new JLabel("[link]");
		assignlabel.addMouseListener(new MouseAdapter(){

			public void mousePressed(MouseEvent e) {
				if(!assignlabel.isEnabled()) return;
				
				assignlabel.setForeground(PRESSED_COLOR);
			}

			public void mouseReleased(MouseEvent e) {
				if(!assignlabel.isEnabled()) return;
				
				assignlabel.setForeground(DEFAULT_COLOR );
				parent.assignSelection();
			}
		});
		
		unassignlabel = new JLabel("[unlink]");
		unassignlabel.addMouseListener(new MouseAdapter(){

			public void mousePressed(MouseEvent e) {
				if(!unassignlabel.isEnabled()) return;
				
				unassignlabel.setForeground(PRESSED_COLOR);
			}

			public void mouseReleased(MouseEvent e) {
				if(!unassignlabel.isEnabled()) return;
				
				unassignlabel.setForeground(DEFAULT_COLOR );
				parent.unassignSelection();
			}
		});
		
		refreshlabel = new JLabel("[refresh]");
		refreshlabel.addMouseListener(new MouseAdapter(){

			public void mousePressed(MouseEvent e) {
				refreshlabel.setForeground(PRESSED_COLOR);
			}

			public void mouseReleased(MouseEvent e) {
				
				refreshlabel.setForeground(DEFAULT_COLOR );
				parent.refreshData();
			}
		});
		
		showlabel.setFont(new Font("Arial", Font.PLAIN, 11));
		assignlabel.setFont(new Font("Arial", Font.PLAIN, 11));
		unassignlabel.setFont(new Font("Arial", Font.PLAIN, 11));
		refreshlabel.setFont(new Font("Arial", Font.PLAIN, 11));
		
		unassignlabel.setForeground(DEFAULT_COLOR );
		assignlabel.setForeground(DEFAULT_COLOR );
		showlabel.setForeground(DEFAULT_COLOR );
		refreshlabel.setForeground(DEFAULT_COLOR );
		
		setBackground(Color.white);
		add(showlabel);
		add(assignlabel);
		add(unassignlabel);
		add(refreshlabel);
		
		showlabel.setEnabled(false);
		assignlabel.setEnabled(false);
		unassignlabel.setEnabled(false);
		
		showlabel.setToolTipText("Show pen data on score");
		assignlabel.setToolTipText("Link data with score");
		unassignlabel.setToolTipText("Unlink data from score");
		refreshlabel.setToolTipText("Refesh data");
	}

	
	
}
