package inria.paperoles.ui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JToolBar;

public class FunctionsBar extends JToolBar{

	final static int DEFAULT_HEIGHT = 200;
	final static String PLUS_FILENAME = "plus.png";
	final static String PRESS_PLUS_FILENAME = "plus-pressed.png";
	
	OperationsList list;
	GestureBrowser frame;
	
	public FunctionsBar(GestureBrowser browser){
		super("Functionality");
		setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		
		JLabel title = new JLabel("Operations");
		
		title.setAlignmentX(LEFT_ALIGNMENT);	
		title.setFont(new Font("Arial", Font.ITALIC, 12));
		
		title.setBorder(BorderFactory.createEmptyBorder(6,0,6,6));
		
        setOrientation(JToolBar.VERTICAL);

        list = new OperationsList(browser.gcontainer);
		JScrollPane scrollPane = new JScrollPane(list, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		scrollPane.setPreferredSize(new Dimension(GlobalParameters.DICTIONARY_ITEM_WIDTH*2 + 49, 150));
		
		JButton addButton = new JButton(new ImageIcon(GlobalParameters.ICONS_FOLDER + PLUS_FILENAME));
		addButton.setPressedIcon(new ImageIcon(GlobalParameters.ICONS_FOLDER + PRESS_PLUS_FILENAME));
		addButton.setBorderPainted(false);
		addButton.setToolTipText("Define new operation");
		
		JPanel titleBar = new JPanel();
		titleBar.setBorder(BorderFactory.createEmptyBorder(6,6,6,6));
		titleBar.setLayout(new BorderLayout());
		titleBar.add(title, BorderLayout.LINE_START);
		titleBar.add(addButton, BorderLayout.LINE_END);
		add(titleBar);
		titleBar.setMaximumSize(titleBar.getPreferredSize());
	//	setPreferredSize(new Dimension(getPreferredSize().width, DEFAULT_HEIGHT));
		add(scrollPane);
		
		titleBar.setAlignmentX(LEFT_ALIGNMENT);
		scrollPane.setAlignmentX(LEFT_ALIGNMENT);

		frame = browser;
		
		addButton.addActionListener(new ActionListener(){

			public void actionPerformed(ActionEvent e) {
				JButton button = (JButton)(e.getSource());
				//System.err.println((int)button.getBounds().getX() - 2 + "\n" + (int)button.getBounds().getMaxY() + 2);
				
				OperationDefinitionDialog dialog = new OperationDefinitionDialog(frame,
						(int)button.getLocationOnScreen().getX() - 2, 
						(int)button.getLocationOnScreen().getY() + (int)button.getHeight());
				dialog.setVisible(true);
			}
		});
			
		
	}
	
	OperationsList getOperationList(){
		return list;
	}
	
}
