package inria.paperoles.ui;

import java.awt.Dimension;
import java.awt.Font;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JScrollPane;
import javax.swing.JToolBar;

public class GestureDictionaryBar extends JToolBar{

	GestureList glist;
	public GestureDictionaryBar(GestureBrowser browser){
		super("Gesture Dictionary");
		setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		
		JLabel title = new JLabel("Defined Gestures");
		
		title.setAlignmentX(LEFT_ALIGNMENT);	
		title.setFont(new Font("Arial", Font.ITALIC, 12));
		title.setBorder(BorderFactory.createEmptyBorder(6,6,6,6));
		
        setOrientation(JToolBar.VERTICAL);
        
        glist = new GestureList(browser.gcontainer);
		JScrollPane scrollPane = new JScrollPane(glist, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		scrollPane.setPreferredSize(new Dimension(GlobalParameters.DICTIONARY_ITEM_WIDTH*2 + 49, 160));
		scrollPane.setAlignmentX(LEFT_ALIGNMENT);
		
		add(title);
        add(scrollPane);
	}
	
	public GestureList getGestureList(){
		return glist; 
		//(GestureList)((JScrollPane)getComponentAtIndex(1)).getViewport().getView();
	}
	
	public void clean(){
		glist.removeAll();	
	}
}
