package inria.paperoles.ui;

import java.awt.Color;
import java.awt.Rectangle;
import java.awt.geom.Rectangle2D;

import inria.paperoles.gestures.GeneralInkStroke;
import edu.umd.cs.piccolo.nodes.PPath;

public class GestureHandle extends PPath{

	final static int MIN_SIZE = 20;
	final static Color OVER_PAINT = new Color(255, 255, 255, 0);
	
	public GestureHandle(GeneralInkStroke stroke){
		double width = Math.max(MIN_SIZE, stroke.getBounds().getWidth());
		double height = Math.max(MIN_SIZE, stroke.getBounds().getHeight());
		
		setPathTo(new Rectangle2D.Double((stroke.getBounds().getCenterX() - width/2), (stroke.getBounds().getCenterY() - height/2), width, height));
		
		setStrokePaint(null);
		setPaint(OVER_PAINT);
	}
}
