package inria.paperoles.ui;

import java.awt.BasicStroke;
import java.awt.Color;

import edu.umd.cs.piccolo.nodes.PPath;

public class GraphButton extends PPath{

	ScoreViewer graphViewer;
	final static Color STROKE_PAINT = new Color(90, 190, 170);
	final static Color FOCUS_STROKE_PAINT = new Color(100, 110, 160);
	final static Color PRESS_STROKE_PAINT = new Color(160, 170, 230);
	
	final static  Color GRID_COLOR = new Color(110, 210, 180);
	
	public GraphButton(ScoreViewer graphViewer, double offx, double offy, int w, int h){
		super();
		
		setPathToRectangle((float)offx, (float)offy, w, h);
		
		setStrokePaint(STROKE_PAINT);
		setPaint(new Color(250, 250, 250, 100));
		
		this.graphViewer = graphViewer;
		
		drawGrid((int)offx, (int)offy, w, h);
	}

	private void drawGrid(int x, int y, int w, int h){
		PPath grid = new PPath();
		grid.setStrokePaint(GRID_COLOR);
		
		grid.setStroke(new BasicStroke((float) .8));
		// (1) create all the horizontal lines for centimeters
		grid.moveTo(x + 1, y + 7);
		grid.lineTo(x + w - 1, y + 7);
		
		grid.moveTo(x + 1, y + 19);
		grid.lineTo(x + w - 1, y + 19);		
		
		grid.moveTo(x + 7, y + 1);
		grid.lineTo(x + 7, y + h - 1);	
		
		grid.moveTo(x + 19, y + 1);
		grid.lineTo(x + 19, y + h -1);	

		addChild(grid);
		
		grid.setPickable(false);
	}

	public void entered() {
		setStrokePaint(FOCUS_STROKE_PAINT);
	}
	
	public void exited() {
		setStrokePaint(STROKE_PAINT);
	}
	 
	public void pressed() {
		setStrokePaint(PRESS_STROKE_PAINT);
	}

	public void released(boolean in) {
		if(in) setStrokePaint(FOCUS_STROKE_PAINT);
		else setStrokePaint(STROKE_PAINT);
		
		CurvesWindow win = new CurvesWindow(((ScoreViewer)(getBar().viewer)).getParentFrame(),
				graphViewer, 70, 70);
	}
	
	public GraphsBar getBar(){
		return (GraphsBar)getParent();
	}

	public void highlight(boolean b) {
		if(b) setStrokePaint(Color.red);
		else setStrokePaint(STROKE_PAINT);
	}
}
