package inria.paperoles.ui;

import inria.paperoles.operations.Operation;
import inria.paperoles.ui.menus.JMarkingMenu;

import java.awt.Dimension;
import java.awt.geom.Point2D;
import java.util.SortedMap;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JLayeredPane;
import javax.swing.JScrollPane;


public class InteractionSurface extends JLayeredPane{

	//ScoreContainer scoreContainer;
	JScrollPane scoreContainer;
	GestureBrowser gbrowser;
	
	public InteractionSurface(JScrollPane scoreContainer, GestureBrowser  gbrowser){
		super();
		
		this.gbrowser = gbrowser;
		Dimension size = scoreContainer.getPreferredSize();
		
		this.scoreContainer = scoreContainer;
		scoreContainer.setBounds(0, 0, (int)size.getWidth(), 
				(int)size.getHeight());
		
		add(scoreContainer, JLayeredPane.DEFAULT_LAYER);
		
		setBounds(0, 0, (int)size.getWidth(), (int)size.getHeight());
		setPreferredSize(size);
		setMaximumSize(size);
		setMinimumSize(size);
	}

	JMarkingMenu menu;
	public void addMenu(JMarkingMenu menu){
		this.menu = menu;
		menu.setBounds();
		add(menu, JLayeredPane.POPUP_LAYER, menu.getNesting());
	}
	
	public SortedMap<String, Operation> getOperations(){
		return gbrowser.getOperationsList().getOperationsMap();
	}
	
	public void removeActiveMenu(){
		remove(menu);
	}
	
	public void update(){
		if(scoreContainer instanceof ScoreContainer) 
			((ScoreContainer)scoreContainer).update();
	}
	
	public void updateSize() {
		scoreContainer.setBounds(0, 0, (int)getBounds().getWidth(), (int)getBounds().getHeight());
	}
	
	public OutputWindow getOutput(){
		return gbrowser.outwindow;
	}
}
