package inria.paperoles.ui;

public class PaperTemplate{
	String id;
	int offset_x, offset_y;
	int ink_offset_x, ink_offset_y;
	double scalex, scaley;
	boolean isPortrait = true;
	boolean isDefault = false;

	public PaperTemplate(){}
	
	public PaperTemplate(String line){
		String args[] = line.split(" ");
		
		id = args[0];
		offset_x = new Integer(args[1]).intValue();
		offset_y = new Integer(args[2]).intValue();
		
		ink_offset_x = new Integer(args[3]).intValue();
		ink_offset_y = new Integer(args[4]).intValue();
		
		scalex =  new Double(args[5]).doubleValue();
		scaley =  new Double(args[6]).doubleValue();
		
		isPortrait = (args[7].startsWith("true"));
		
		isDefault = args.length > 8 && args[8].startsWith("*");
	}
	
	public int getOffsetX(){
		return offset_x;
	}
	
	public int getOffsetY(){
		return offset_y;
	}
	
	public int getInkOffsetX(){
		return ink_offset_x;
	}
	
	public int getInkOffsetY(){
		return ink_offset_y;
	}
	
	public double getXScale(){
		return scalex;
	}
	
	public double getYScale(){
		return scaley;
	}
	
	public boolean isPortrait(){
		return isPortrait;
	}
	
	public boolean isDefault(){
		return isDefault;
	}	
}

