package inria.paperoles.ui;

import edu.umd.cs.piccolo.event.PInputEvent;
import inria.paperoles.customization.GestureManipulationCommand;
import inria.paperoles.ui.menus.JMarkingMenuOption;

public class ScopeRefinementOption extends MarkingMenuOption{

	public ScopeRefinementOption(JMarkingMenuOption visualLabel, GestureManipulationCommand option,
			Object argument, double x, double y) {
		super(visualLabel, option, argument, x, y);
		
		if(option.getGesturePath().getToken().getAlternativeScopes().size() < 2 
				|| option.getGesturePath().getGestureClass() != null
				|| option.getGesturePath().scope == null
				|| !option.getGesturePath().scope.getVisible()){
			setInactive();
		}
	}
	
	ScopeMenu menu;
	public void gainFocus() {
		if(!active) return;
		if(label!=null) label.gainFocus();
		((MarkingMenu)getParent()).hide();
		
		GesturePath gpath = option.getGesturePath();
		menu = new ScopeMenu(gpath);
		gpath.getCanvas().addScopeMenu(gpath, menu);
	}
	
	public void handleEvent(PInputEvent event) {
		menu.handleEvent(event);
	}
}
