package inria.paperoles.ui;

import inria.paperoles.uievents.ScrollListener;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridLayout;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;


public class ScoreContainer extends JScrollPane {
	
	final static int INSET = 5;
	MultiplePageViewer viewer;
	JPanel panel;
	
	public ScoreContainer(MultiplePageViewer viewer, int width, int height){
		super();
		
		this.viewer = viewer;
		panel = new JPanel();
		panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
		
		JLabel dummy = new JLabel("       ");
		panel.add(dummy);
		dummy.setAlignmentX(Component.CENTER_ALIGNMENT);
		
		for(int i = 0; i < viewer.getPageNum(); ++i){
			ScoreViewer pageViewer  = viewer.get(i);
			Dimension dim = pageViewer.getMaximumSize();
			
			pageViewer.setAlignmentX(Component.CENTER_ALIGNMENT);
			panel.add(pageViewer);
			//pageViewer.setBounds(0, (dim.height+INSET)*i, dim.width, dim.height*(i+1));

			panel.add(Box.createRigidArea(new Dimension(0,5)));
		}
		
		panel.setBackground(Color.gray);
// need to change that....		
		panel.setPreferredSize(viewer.getSize());
		
		JPanel p = new JPanel();
		p.setBackground(Color.gray);
		p.setLayout(new BorderLayout());
		p.add(panel, BorderLayout.NORTH);
		setViewportView(p);
		
		setPreferredSize(new Dimension(width, height));
	}
	
	void update(){
		panel.removeAll();
		
		JLabel dummy = new JLabel("       ");
		panel.add(dummy);
		dummy.setAlignmentX(Component.CENTER_ALIGNMENT);
		
		for(int i = 0; i < viewer.getPageNum(); ++i){
			ScoreViewer pageViewer  = viewer.get(i);
			Dimension dim = pageViewer.getMaximumSize();
			
			pageViewer.setAlignmentX(Component.CENTER_ALIGNMENT);
			panel.add(pageViewer);
			//pageViewer.setBounds(0, (dim.height+INSET)*i, dim.width, dim.height*(i+1));

			panel.add(Box.createRigidArea(new Dimension(0,5)));
		}
		panel.setPreferredSize(viewer.getSize());
	}
	
}
