package inria.paperoles.ui.menus;

import inria.paperoles.ui.InteractionSurface;

import java.awt.Color;

import java.awt.geom.Point2D;

import javax.swing.BorderFactory;
import javax.swing.JComponent;
import javax.swing.JLabel;


public class JMarkingMenu extends JComponent{
	
	int center_x, center_y;
	
	int x = 0, y=0, x2=0, y2=0;
	int nesting;
	
	public JMarkingMenu(Point2D center, int nesting){
		super();
		
		this.nesting = 1 - nesting;
		center_x = (int)(center.getX());
		center_y = (int)(center.getY());
	}

	public int getNesting(){
		return nesting;
	}
	
	public void addOption(JMarkingMenuOption option){
		add(option);

		option.setBounds((int)(center_x + option.getRelativePosition().getX()), 
				(int)(center_y + option.getRelativePosition().getY()), (int)option.getPreferredSize().getWidth(),
				(int)option.getPreferredSize().getHeight());
		
		x = (int) Math.min(x, option.getBounds().getX());
		y = (int) Math.min(y, option.getBounds().getY());
		x2 = (int) Math.max(x2, option.getBounds().getX() + option.getBounds().getWidth());
		y2 = (int) Math.max(y2, option.getBounds().getY() + option.getBounds().getHeight());
	}
	
	public void setBounds(){
		setBounds(x, y, x2-x, y2-y);
	}

	public void remove(){
		InteractionSurface parent = (InteractionSurface) getParent();
		parent.remove(this);
		parent.repaint();
	}

	public void enableMenu(boolean b) {
		for(int i =0; i<this.getComponentCount(); ++i){
			JMarkingMenuOption option = (JMarkingMenuOption)getComponent(i);
			option.enableOption(b);
		}
	}
	
	public void hide(){
		for(int i =0; i<this.getComponentCount(); ++i){
			JMarkingMenuOption option = (JMarkingMenuOption)getComponent(i);
			if(!option.hasFocus()) option.setVisible(false);
			else option.enableOption(false);
		}
	}
}
