package inria.paperoles.ui.menus;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Image;
import java.awt.geom.Point2D;

import javax.swing.BorderFactory;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.SwingConstants;

public class JMarkingMenuOption extends JLabel {

	Point2D position;
	
	public JMarkingMenuOption(String label, double x, double y){
			super(label);
			//setBorder(BorderFactory.createEmptyBorder(15,15,15,15));
			setPreferredSize(new Dimension((int)getPreferredSize().width + 6, (int)getPreferredSize().height + 4));
			setHorizontalAlignment(SwingConstants.CENTER);
			this.position = new Point2D.Double(x - getPreferredSize().width/2, y- getPreferredSize().height/2);
			
			setOpaque(true);
			setBackground(Color.white);
			setForeground(Color.black);
			setBorder(BorderFactory.createLineBorder(Color.black));
	}
	
	public JMarkingMenuOption(String label, Icon icon, double x, double y) {
		super(label, icon, JLabel.CENTER);
		setVerticalTextPosition(JLabel.BOTTOM);
		setHorizontalTextPosition(JLabel.CENTER);
		
		setPreferredSize(new Dimension((int)getPreferredSize().width + 6, (int)getPreferredSize().height + 4));
		this.position = new Point2D.Double(x - getPreferredSize().width/2, y- getPreferredSize().height/2);
		
		setOpaque(true);
		setBackground(Color.white);
		setForeground(Color.black);
		setBorder(BorderFactory.createLineBorder(Color.gray));
	}

	public Point2D getRelativePosition(){
		return position;
	}

	public boolean hasFocus(){
		return focus;
	}
	
	boolean focus = false;
	public void loseFocus() {
		if(locked) return;
		setBackground(Color.white);
		focus = false;
	}

	public void gainFocus() {
		if(locked) return;
		setBackground(new Color(220, 220, 200));
		focus = true;
	}

	boolean locked = false;
	public void lock(){
		enableOption(false);
		locked = true;
	}
	
	public void enableOption(boolean b) {
		if(locked) return;
		
		if(b){
			setForeground(Color.black);
			setBorder(BorderFactory.createLineBorder(Color.black));
		}
		else{
			setForeground(Color.gray);
			setBorder(BorderFactory.createLineBorder(Color.gray));
		}
		
	}


}
