package inria.paperoles.uievents;

import java.awt.Point;
import java.awt.geom.Point2D;
import java.util.Vector;

import com.sun.org.apache.bcel.internal.generic.GETSTATIC;

import inria.paperoles.customization.ClassifyAsCommand;
import inria.paperoles.customization.CommandArgumentSet;
import inria.paperoles.customization.GestureDefinitionCommand;
import inria.paperoles.customization.GestureManipulationCommand;
import inria.paperoles.customization.GestureRecognitionCommand;
import inria.paperoles.customization.GestureRemovalCommand;
import inria.paperoles.customization.ScopeRefinementCommand;
import inria.paperoles.customization.UnclassifyCommand;
import inria.paperoles.gestures.recognition.GeneralizedGestureClass;
import inria.paperoles.grammar.ArrowConnector;
import inria.paperoles.grammar.ConnectorToken;
import inria.paperoles.grammar.SelectorToken;
import inria.paperoles.operations.Operation;
import inria.paperoles.ui.GestureBrowser;
import inria.paperoles.ui.GestureHandle;
import inria.paperoles.ui.GesturePath;
import inria.paperoles.ui.GesturesCanvas;
import inria.paperoles.ui.GraphButton;
import inria.paperoles.ui.InteractionSurface;
import inria.paperoles.ui.MarkingMenu;
import inria.paperoles.ui.ScoreViewer;

import inria.paperoles.ui.ScopeInteractor;
import edu.umd.cs.piccolo.PCamera;
import edu.umd.cs.piccolo.PNode;
import edu.umd.cs.piccolo.event.PBasicInputEventHandler;
import edu.umd.cs.piccolo.event.PInputEvent;
import edu.umd.cs.piccolo.nodes.PPath;

public class GraphButtonEventHandler extends PBasicInputEventHandler{

	public GraphButtonEventHandler() {

	}
	
	public void mouseEntered(PInputEvent event){
		GraphButton button = (GraphButton) event.getPickedNode();
		
		button.entered();
	}
	
	public void mouseExited(PInputEvent event){
		GraphButton button = (GraphButton)event.getPickedNode();
		
		button.exited();
	}
	
	public void mousePressed(PInputEvent event){
		GraphButton button = (GraphButton)event.getPickedNode();
		
		button.pressed();
	}
	
	public void mouseReleased(PInputEvent event){
		GraphButton button = (GraphButton)event.getPickedNode();

		button.released(button.getBounds().contains(event.getPosition()));
	}
}